<!--
 * @Author: zhp
 * @Date: 2023-07-13 11:18:36
 * @LastEditTime: 2023-07-13 13:49:00
 * @LastEditors: zhp
 * @Description: 
-->
<!--
 * @Author: zhp
 * @Date: 2023-02-14 15:02:26
 * @LastEditTime: 2023-07-12 14:04:19
 * @LastEditors: zhp
 * @Description: 
-->
<template>
  <el-form :model="dataForm" ref="dataForm" :rules="dataRule" @keyup.enter.native="dataFormSubmitHandle()"
    label-width="120px">
    <el-form-item prop="processCode" :label="$t('basic.code')">
      <el-input v-model="dataForm.processCode" :placeholder="$t('basic.code')"></el-input>
    </el-form-item>
    <el-form-item prop="processName" :label="$t('basic.name')">
      <el-input v-model="dataForm.processName" :placeholder="$t('basic.name')"></el-input>
    </el-form-item>
    <el-form-item prop="remark" :label="$t('basic.remark')">
      <el-input v-model="dataForm.remark" :placeholder="$t('basic.remark')"></el-input>
    </el-form-item>
  </el-form>
</template>

<script>
import debounce from "lodash/debounce";
import basicAdd from "@/mixins/basic-add";
export default {
  mixins: [basicAdd],
  data() {
    return {
      urlOptions: {
        submitURL: "/basic/qmsProcess",
        infoURL: "/basic/qmsProcess/{id}",
        getCodeURL: '/basic/qmsProcess/getCode'
      },
      options: [{
        value: 0,
        label: '不可用'
      },
      {
        value: 1,
        label: '可用'
      }],
      visible: false,
      dataForm: {
        id: "",
        processCode:null,
        processName:null,
        remark:null
      },
    };
  },
  computed: {
    dataRule() {
      return {
        processName: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ],
        processCode: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ]
      };
    },
  },
  methods: {
    init(id, ) {
      this.dataForm.id = id || "";
      // this.dataForm.dictTypeId = dictTypeId || "";
      this.visible = true;
      this.$nextTick(() => {
        this.$refs["dataForm"].resetFields();
        if (this.dataForm.id) {
          this.getInfo();
        } else {
          this.getCode()
        }
      });
    },
    getCode() {
      // console.log(111111);
      this.$http
        .post(this.urlOptions.getCodeURL)
        .then(({ data: res }) => {
          if (res.code === 0) {
            console.log(res);
            this.dataForm.processCode = res.data
          }
        })
        .catch(() => {
        });
    },
    // 获取信息
    getInfo() {
      this.$http
        .get(`/basic/qmsProcess/${this.dataForm.id}`)
        .then(({ data: res }) => {
          if (res.code !== 0) {
            return this.$message.error(res.msg);
          }
          this.dataForm = {
            ...this.dataForm,
            ...res.data,
          };
        })
        .catch(() => {});
    },
    // 表单提交
    dataFormSubmitHandle: debounce(
      function () {
        this.$refs["dataForm"].validate((valid) => {
          if (!valid) {
            return false;
          }
          this.$http[!this.dataForm.id ? "post" : "put"](this.urlOptions.submitURL, this.dataForm)
            .then(({ data: res }) => {
              if (res.code !== 0) {
                return this.$message.error(res.msg);
              }
              this.$message({
                message: this.$t("prompt.success"),
                type: "success",
                duration: 500,
                onClose: () => {
                  console.log(1111);
                  this.visible = false;
                  this.$emit("successSubmit");
                },
              });
            })
            .catch(() => {});
        });
      },
      1000,
      { leading: true, trailing: false }
    ),
  },
};
</script>
